Name:           guacamole
Version:        0.8.1
Release:        2%{?dist}
Summary:        The main Guacamole web application
License:        MPLv1.1 or GPLv2+ or LGPLv2+
URL:            http://guac-dev.org/
Source0:        http://downloads.sourceforge.net/guacamole/%{name}-%{version}.tar.gz
# Remove javascript as according to packaging guidelines these must be present
# in unpacked form on the filesystem. See:
# http://fedoraproject.org/wiki/JavaScript_libraries_packaging_guideline_draft
Patch0:         %{name}-0.6.2-js.patch
Patch1:         %{name}-0.6.2-allow-linking.patch
BuildArch:      noarch

BuildRequires:  guacamole-common >= 0.8.0
BuildRequires:  guacamole-ext >= 0.8.0
BuildRequires:  maven-local
BuildRequires:  maven-clean-plugin
BuildRequires:  maven-dependency-plugin
BuildRequires:  maven-war-plugin
BuildRequires:  servlet3
Requires:       guacamole-common >= 0.8.0
Requires:       guacamole-common-js >= 0.7.1
Requires:       guacamole-ext >= 0.8.0
Requires:       java
Requires:       log4j
Requires:       slf4j
Requires:       tomcat
Requires:       tomcat-native

%description
This package contains the main HTML5 web application for the Guacamole stack
that provides access to desktop environments using remote desktop protocols such
as VNC or RDP.

A centralized server acts as a tunnel and proxy, allowing access to multiple
desktops through a web browser. No plugins are needed: the client requires
nothing more than a web browser supporting HTML5 and AJAX.

The centralized server is provided by the "guacd" package and its associated
"libguac-client-*" packages.

%package javadoc
Summary:          API documentation for %{name}
Group:            Documentation

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1
%patch1 -p1

%build
# https://fedoraproject.org/wiki/Packaging:Java#Patching_Maven_pom.xml_files
%pom_remove_dep net.sourceforge.guacamole:guacamole-common-js

mvn-rpmbuild package javadoc:aggregate

%install
# https://fedoraproject.org/wiki/PackagingDrafts/JavaWebApps

# Put data files into tomcat's webapps directory
mkdir -p %{buildroot}%{_sharedstatedir}/tomcat/webapps/%{name}/
cp -frp target/%{name}-%{version}/* %{buildroot}%{_sharedstatedir}/tomcat/webapps/%{name}/

# Use Fedora packaged jar files & java scripts
rm -f %{buildroot}%{_sharedstatedir}/tomcat/webapps/%{name}/WEB-INF/lib/*.jar
ln -sf %{_javadir}/guacamole-ext/guacamole-ext.jar %{buildroot}%{_sharedstatedir}/tomcat/webapps/%{name}/WEB-INF/lib/
ln -sf %{_javadir}/guacamole-common/guacamole-common.jar %{buildroot}%{_sharedstatedir}/tomcat/webapps/%{name}/WEB-INF/lib/
ln -sf %{_javadir}/slf4j/api.jar %{buildroot}%{_sharedstatedir}/tomcat/webapps/%{name}/WEB-INF/lib/
ln -sf %{_javadir}/slf4j/jcl-over-slf4j.jar %{buildroot}%{_sharedstatedir}/tomcat/webapps/%{name}/WEB-INF/lib/
ln -sf %{_datadir}/guacamole-common-js %{buildroot}%{_sharedstatedir}/tomcat/webapps/%{name}/

# Configuration file
mkdir -p %{buildroot}%{_sysconfdir}/%{name}
cp -p doc/example/* %{buildroot}%{_sysconfdir}/%{name}
sed -i -e 's@/path/to@%{_sysconfdir}/%{name}@g' %{buildroot}%{_sysconfdir}/%{name}/%{name}.properties
ln -sf %{_sysconfdir}/%{name}/%{name}.properties %{buildroot}%{_sharedstatedir}/tomcat/webapps/%{name}/WEB-INF/classes/

# Docs
mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -rp target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}/

%files
%doc COPYING README
%{_sharedstatedir}/tomcat/webapps/%{name}
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/user-mapping.xml
%config(noreplace) %{_sysconfdir}/%{name}/guacamole.properties

%files javadoc
%doc COPYING
%{_javadocdir}/%{name}

%changelog
* Wed Jun 19 2013 Simone Caronni <negativo17@gmail.com> - 0.8.1-2
- Fix license.

* Fri Jun 07 2013 Simone Caronni <negativo17@gmail.com> - 0.8.1-1
- Update to 0.8.1.

* Tue Mar 26 2013 Simone Caronni <negativo17@gmail.com> - 0.8.0-3
- Updated spec file for Java guidelines.

* Mon Mar 25 2013 Simone Caronni <negativo17@gmail.com> - 0.8.0-2
- Source rebuilt upstream due to bug: http://guac-dev.org/trac/ticket/298

* Thu Mar 21 2013 Simone Caronni <negativo17@gmail.com> - 0.8.0-1
- Update to 0.8.0.

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Tue Jan 22 2013 Simone Caronni <negativo17@gmail.com> - 0.7.1-1
- Updated to 0.7.1, requires >= 0.7.0 components.

* Mon Jan 21 2013 Simone Caronni <negativo17@gmail.com> - 0.7.0-4
- Added missing slf4j requirement.

* Wed Jan 16 2013 Simone Caronni <negativo17@gmail.com> - 0.7.0-3
- Removed pom.xml as per info in #fedora-java.

* Tue Jan 15 2013 Simone Caronni <negativo17@gmail.com> - 0.7.0-2
- Added Tomcat requirements (log4j, tomcat, tomcat-native).
- Moved application from /usr/share/webapps/guacamole/guacamole to
  /var/lib/tomcat/webapps/guacamole.
- Moved docs outside of the "apidocs" folder.
- Changed description with notes where to get the centralized server.
- Added pom.xml to installed files.
- Moved config file to /etc/guacamole and linked it to WEB-INF/classes.

* Tue Dec 18 2012 Simone Caronni <negativo17@gmail.com> - 0.7.0-1
- Updated.

* Fri Nov 30 2012 Simone Caronni <negativo17@gmail.com> - 0.6.2-2
- Fixed required jars' symlinks and properties file.
- Allow linking in webapp context.xml.

* Wed Oct 31 2012 Simone Caronni <negativo17@gmail.com> - 0.6.2-1
- Updated to 0.6.2.
- Add links relative to guacamole-common-js dependency removal.

* Thu Sep 13 2012 Simone Caronni <negativo17@gmail.com> - 0.6.1-2
- Change Source0 URL.

* Mon Sep 03 2012 Simone Caronni <negativo17@gmail.com> - 0.6.1-1
- First build.
